import { PropType } from 'vue';
import { IOrganizationCurrentData, IOrganizationTreeItem } from '../../interface';
declare const _default: import("vue").DefineComponent<{
    isDraggable: {
        required: false;
        type: BooleanConstructor;
    };
    item: {
        required: true;
        type: PropType<IOrganizationTreeItem>;
    };
    lastIndex: {
        required: true;
        type: NumberConstructor;
    };
}, unknown, {
    draggedCards: string[];
    dropTarget: string | null;
    onDropTimeout: any;
}, {}, {
    handleDragCard(ev: DragEvent, item: IOrganizationTreeItem): void;
    handleDragEnd(ev: DragEvent): void;
    handleDragEnter(ev: DragEvent): void;
    handleDragLeave(): void;
    handleDropCard(ev: DragEvent, item: IOrganizationTreeItem): void;
    handleEmitChange(parent: IOrganizationCurrentData, target: IOrganizationCurrentData): void;
    isDragged(id: string): boolean;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    changeItem: (_parent: IOrganizationCurrentData, _target: IOrganizationCurrentData) => true;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    isDraggable: {
        required: false;
        type: BooleanConstructor;
    };
    item: {
        required: true;
        type: PropType<IOrganizationTreeItem>;
    };
    lastIndex: {
        required: true;
        type: NumberConstructor;
    };
}>> & {
    onChangeItem?: ((_parent: IOrganizationCurrentData, _target: IOrganizationCurrentData) => any) | undefined;
}, {
    isDraggable: boolean;
}, {}>;
export default _default;
