import "./organization-tree.css";
import { defineComponent as L, resolveComponent as k, openBlock as d, createElementBlock as o, normalizeClass as P, Fragment as I, mergeProps as u, withModifiers as l, toDisplayString as f, createCommentVNode as m, renderList as C, createBlock as $, normalizeStyle as E, createElementVNode as h } from "vue";
import { _ as c } from "../../_plugin-vue_export-helper-dad06003.js";
const S = (e) => {
  let r = [];
  return [...e].map((t) => (t.childs && t.childs.length && (r = [...r, ...t.childs]), t)).concat(r.length ? S(r) : r);
}, O = (e, r) => e.childs ? {
  ...e,
  childs: [...e.childs, { ...r }]
} : { ...e }, z = (e, r, t) => e.childs ? [...e.childs].some(
  (a) => a.path === r
) ? {
  ...e,
  childs: [...e.childs].map((a) => a.path === r ? {
    ...a,
    childs: [...a.childs || [], t]
  } : a)
} : {
  ...e,
  childs: [...e.childs].map(
    (a) => z(a, r, t)
  )
} : e, q = (e, r) => {
  const t = [e], s = [...S(e.childs || [])];
  return [...t, ...s].find(
    (a) => a.path === r
  );
}, M = (e, r, t) => e.childs ? [...e.childs].some(
  (a) => a.path === r
) ? {
  ...e,
  childs: [...e.childs].map((a) => a.path === r ? t : a)
} : {
  ...e,
  childs: [...e.childs].map(
    (a) => M(a, r, t)
  )
} : e, v = (e, r) => e.childs ? [...e.childs].some(
  (s) => s.path === r
) ? {
  ...e,
  childs: [...e.childs].filter(
    (s) => s.path !== r
  )
} : {
  ...e,
  childs: [...e.childs].map(
    (s) => v(s, r)
  )
} : e, A = L({
  emits: {
    changeItem: (e, r) => !0
  },
  props: {
    isDraggable: {
      required: !1,
      type: Boolean
    },
    item: {
      required: !0,
      type: Object
    },
    lastIndex: {
      required: !0,
      type: Number
    }
  },
  name: "sb-organization-tree-item",
  data() {
    return {
      draggedCards: [],
      dropTarget: null,
      onDropTimeout: null
    };
  },
  computed: {},
  methods: {
    handleDragCard(e, r) {
      var s;
      e.stopPropagation();
      const t = e.target;
      this.draggedCards.push(t.id), (s = e.dataTransfer) == null || s.setData(
        "text/html",
        JSON.stringify({
          data: { ...r },
          index: r.path
        })
      );
    },
    handleDragEnd(e) {
      e.stopPropagation();
      const r = e.target;
      this.draggedCards = [...this.draggedCards].filter(
        (t) => t !== r.id
      );
    },
    handleDragEnter(e) {
      const r = e.target;
      this.dropTarget = r.id, this.onDropTimeout && clearTimeout(this.onDropTimeout);
    },
    handleDragLeave() {
      this.onDropTimeout = setTimeout(() => {
        this.dropTarget = null;
      }, 50);
    },
    handleDropCard(e, r) {
      var s;
      e.stopPropagation(), this.handleDragLeave();
      const t = (s = e.dataTransfer) == null ? void 0 : s.getData("text/html");
      if (t) {
        const a = t.replace(
          '<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">',
          ""
        ), i = {
          ...JSON.parse(a)
        };
        this.$emit(
          "changeItem",
          {
            data: r,
            index: r.path
          },
          i
        );
      }
    },
    handleEmitChange(e, r) {
      this.$emit("changeItem", e, r);
    },
    isDragged(e) {
      return this.draggedCards.indexOf(e) > -1;
    }
  }
}), w = ["id"], B = {
  key: 1,
  class: "parent-tree"
}, N = ["id"], H = { class: "data-wrapper" }, j = { class: "name" }, J = { class: "position" }, F = ["innerHTML"], G = ["id"], R = { class: "data-wrapper" }, U = { class: "name" }, V = { class: "position" }, K = ["innerHTML"], Q = { class: "parent-tree" };
function W(e, r, t, s, a, i) {
  var p, y, T, b;
  const g = k("sb-organization-tree-item");
  return d(), o("li", {
    class: P(["child-tree", {
      "has-childs": !!((p = e.item.childs) != null && p.length)
    }])
  }, [
    e.item.department ? (d(), o(I, { key: 0 }, [
      e.item.department ? (d(), o("div", u({
        key: 0,
        class: ["department", {
          "has-childs": !!((y = e.item.childs) != null && y.length),
          draggable: e.isDraggable,
          dragged: e.isDragged(String(e.lastIndex)),
          droparea: e.dropTarget === String(e.lastIndex)
        }],
        id: String(e.lastIndex)
      }, {
        draggable: e.isDraggable
      }, {
        onDragend: r[0] || (r[0] = (...n) => e.handleDragEnd && e.handleDragEnd(...n)),
        onDragenter: r[1] || (r[1] = l((...n) => e.handleDragEnter && e.handleDragEnter(...n), ["prevent"])),
        onDragleave: r[2] || (r[2] = l((...n) => e.handleDragLeave && e.handleDragLeave(...n), ["prevent"])),
        onDragover: r[3] || (r[3] = l((...n) => e.handleDragEnter && e.handleDragEnter(...n), ["prevent"])),
        onDragstart: r[4] || (r[4] = (n) => e.handleDragCard(n, e.item)),
        onDrop: r[5] || (r[5] = l((n) => e.handleDropCard(n, e.item), ["prevent"]))
      }), f(e.item.department), 17, w)) : m("", !0),
      (T = e.item.childs) != null && T.length ? (d(), o("ul", B, [
        (d(!0), o(I, null, C(e.item.childs, (n, D) => (d(), $(g, u({
          item: n,
          key: `${String(e.$.vnode.key)}-childs-${D}`,
          "last-index": e.lastIndex + D + 1
        }, {
          isDraggable: e.isDraggable
        }, { onChangeItem: e.handleEmitChange }), null, 16, ["item", "last-index", "onChangeItem"]))), 128))
      ])) : m("", !0)
    ], 64)) : (b = e.item.childs) != null && b.length ? (d(), o(I, { key: 2 }, [
      h("div", u({
        class: ["card has-childs", {
          draggable: e.isDraggable && e.lastIndex > 1,
          dragged: e.isDragged(String(e.lastIndex)),
          droparea: e.dropTarget === String(e.lastIndex)
        }],
        id: String(e.lastIndex)
      }, {
        draggable: e.isDraggable && e.lastIndex > 1,
        ...e.lastIndex > 1 && {
          onDragend: e.handleDragEnd,
          onDragstart: (n) => e.handleDragCard(n, e.item)
        }
      }, {
        onDragenter: r[12] || (r[12] = l((...n) => e.handleDragEnter && e.handleDragEnter(...n), ["prevent"])),
        onDragleave: r[13] || (r[13] = l((...n) => e.handleDragLeave && e.handleDragLeave(...n), ["prevent"])),
        onDragover: r[14] || (r[14] = l((...n) => e.handleDragEnter && e.handleDragEnter(...n), ["prevent"])),
        onDrop: r[15] || (r[15] = l((n) => e.handleDropCard(n, e.item), ["prevent"]))
      }), [
        e.item.photo ? (d(), o("div", {
          key: 0,
          class: "item-photo",
          style: E({
            backgroundImage: `url(${e.item.photo})`
          })
        }, null, 4)) : m("", !0),
        h("div", R, [
          h("p", U, f(e.item.name), 1),
          h("p", V, f(e.item.position), 1),
          e.item.additionalInfo ? (d(), o("div", {
            key: 0,
            innerHTML: e.item.additionalInfo
          }, null, 8, K)) : m("", !0)
        ])
      ], 16, G),
      h("ul", Q, [
        (d(!0), o(I, null, C(e.item.childs, (n, D) => (d(), $(g, u({
          item: n,
          key: `${String(e.$.vnode.key)}-childs-${D}`,
          "last-index": e.lastIndex + D + 1
        }, {
          isDraggable: e.isDraggable
        }, { onChangeItem: e.handleEmitChange }), null, 16, ["item", "last-index", "onChangeItem"]))), 128))
      ])
    ], 64)) : (d(), o("div", u({
      key: 1,
      class: ["card", {
        draggable: e.isDraggable,
        dragged: e.isDragged(String(e.lastIndex)),
        droparea: e.dropTarget === String(e.lastIndex)
      }],
      id: String(e.lastIndex)
    }, {
      draggable: e.isDraggable
    }, {
      onDragend: r[6] || (r[6] = (...n) => e.handleDragEnd && e.handleDragEnd(...n)),
      onDragenter: r[7] || (r[7] = l((...n) => e.handleDragEnter && e.handleDragEnter(...n), ["prevent"])),
      onDragleave: r[8] || (r[8] = l((...n) => e.handleDragLeave && e.handleDragLeave(...n), ["prevent"])),
      onDragover: r[9] || (r[9] = l((...n) => e.handleDragEnter && e.handleDragEnter(...n), ["prevent"])),
      onDragstart: r[10] || (r[10] = (n) => e.handleDragCard(n, e.item)),
      onDrop: r[11] || (r[11] = l((n) => e.handleDropCard(n, e.item), ["prevent"]))
    }), [
      e.item.photo ? (d(), o("div", {
        key: 0,
        class: "item-photo",
        style: E({
          backgroundImage: `url(${e.item.photo})`
        })
      }, null, 4)) : m("", !0),
      h("div", H, [
        h("p", j, f(e.item.name), 1),
        h("p", J, f(e.item.position), 1),
        e.item.additionalInfo ? (d(), o("div", {
          key: 0,
          innerHTML: e.item.additionalInfo
        }, null, 8, F)) : m("", !0)
      ])
    ], 16, N))
  ], 2);
}
const X = /* @__PURE__ */ c(A, [["render", W]]), Y = L({
  emits: {
    change: (e) => !0
  },
  props: {
    isDraggable: {
      required: !1,
      type: Boolean
    },
    list: {
      required: !0,
      type: Object
    }
  },
  name: "sb-organization-tree",
  components: {
    "sb-org-tree-item": X
  },
  data() {
    return {
      cardIndex: 1,
      localList: {}
    };
  },
  methods: {
    handleChangeItem(e, r) {
      const t = e.index.replace(`${this.$.uid}-org`, "").split("-").filter((a) => a !== ""), s = r.index.replace(`${this.$.uid}-org`, "").split("-").filter((a) => a !== "");
      if (t.length) {
        if (e.index !== r.index)
          if (s.length < t.length) {
            const a = {
              ...v(
                { ...this.localList },
                e.index
              )
            }, i = [
              ...e.data.childs || []
            ], g = {
              ...q(
                { ...a },
                r.index
              )
            }, p = {
              ...M(
                { ...a },
                r.index,
                {
                  ...e.data,
                  childs: [...i, g]
                }
              )
            };
            this.$emit("change", p);
          } else {
            const a = {
              ...v(
                { ...this.localList },
                r.index
              )
            }, i = {
              ...z(
                { ...a },
                e.index,
                r.data
              )
            };
            this.$emit("change", i);
          }
      } else {
        const a = {
          ...v(
            { ...this.localList },
            r.index
          )
        }, i = {
          ...O({ ...a }, r.data)
        };
        this.$emit("change", i);
      }
    },
    handleModList(e) {
      const r = (t, s, a) => {
        const i = a ? `${a}-childs[${s}]` : `${this.$.uid}-org`;
        return t.childs ? {
          ...t,
          childs: [...t.childs].map(
            (g, p) => g.childs ? r(g, p, i) : {
              ...g,
              path: `${i}-childs[${p}]`
            }
          ),
          path: i
        } : {
          ...t,
          path: i
        };
      };
      this.localList = { ...r(e) };
    }
  },
  watch: {
    list: {
      deep: !0,
      handler(e) {
        Object.keys(e).length || (this.cardIndex = 1), this.handleModList(e);
      }
    }
  },
  mounted() {
    this.cardIndex = 1, this.handleModList({ ...this.list || {} });
  }
});
const Z = {
  key: 0,
  class: "parent-tree"
};
function x(e, r, t, s, a, i) {
  const g = k("sb-org-tree-item");
  return d(), o("div", u({ class: "organization-wrapper" }, { ...e.$attrs }), [
    Object.keys(e.list).length ? (d(), o("ul", Z, [
      (d(), $(g, u({
        item: e.localList,
        key: `${e.$.uid}-org`,
        lastIndex: e.cardIndex
      }, {
        isDraggable: e.isDraggable
      }, { onChangeItem: e.handleChangeItem }), null, 16, ["item", "lastIndex", "onChangeItem"]))
    ])) : m("", !0)
  ], 16);
}
const re = /* @__PURE__ */ c(Y, [["render", x]]);
export {
  re as default
};
